* PACKAGE DEIVEC  !" ϳظͭͲ : ͭؿ¤׻
*
*"  [HIS]  92/12/14(takepiro)
*"         93/04/30(takepiro) ʣǿΰϤäƤ
*"         93/07/14(takepiro) ݥ, ٤ȿʬΥ
*"         99/11/12(takepiro) æ HISTORY б
*
**********************************************************************
      SUBROUTINE LEIVEC
     O             ( GDU    , GDV    , GDW    , GDT    ,
     O               GDTOR  , GDPOR  , 
     I               EIGVCR , EIGVCI ,
     I               NMKMTX , 
     I               NMTLST , NMTMAX , 
     I               NMPLST , NMPMAX , 
     I               NMQLST , NMQMAX , 
     F               OATOR  , OAPOR  , OAT    ,
     C               NMO    , FLAPLA , UVFACT , 
     C               ARAD   , DRAD                       )
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zldim.F"                    !" 礭
*
*"  [OUTPUT]
      REAL       GDU   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GDV   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GDW   ( IDIM, JDIM, 0:KMAX )  !" ľ 
      REAL       GDT   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GDTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
      REAL       GDPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*
*"  [INPUT]
      REAL       EIGVCR( MATDMX )            !" ͭ٥ȥ¿
      REAL       EIGVCI( MATDMX )            !" ͭ٥ȥ
*
      INTEGER    NMKMTX ( NMDIM, 0:KMAX, 3 ) !" ź
      INTEGER    NMTLST  ( NMDIM )           !" MFIX ʬꥹ(ȥ)
      INTEGER    NMPLST  ( NMDIM )           !" MFIX ʬꥹ(ݥ)
      INTEGER    NMQLST  ( NMDIM )           !" MFIX ʬꥹ()
      INTEGER    NMTMAX                      !" NMTLST κź
      INTEGER    NMPMAX                      !" NMPLST κź
      INTEGER    NMQMAX                      !" NMQLST κź
*
      LOGICAL    OATOR , OAPOR , OAT         !" оʪ
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       ARAD  ( 0:KMAX )              !" ٥()
      REAL       DRAD  ( 0:KMAX )              !" ()
*
*"  [INTERNAL WORK]
c$$$      COMMON     /COMWRK/  
c$$$     &             WDTOR, WDPOR, WDDPOR, WDT 
* 
      REAL       WDTOR ( NMDIM , 0:KMAX     )  !" ȥ 
      REAL       WDPOR ( NMDIM , 0:KMAX     )  !" ݥ 
      REAL       WDDPOR( NMDIM , 0:KMAX     )  !" ݥ D_l 
      REAL       WDT   ( NMDIM , 0:KMAX     )  !"   
*
      INTEGER    NML , K 
*
      CALL RESET( WDTOR , NMDIM*KDIM )
      CALL RESET( WDPOR , NMDIM*KDIM )
      CALL RESET( WDDPOR, NMDIM*KDIM )
      CALL RESET( WDT   , NMDIM*KDIM )
*
*"     < 1. ͭ٥ȥη׻(ڥȥ) >
*
      IF ( OATOR ) THEN
         DO 1100 K = 1, KMAX-1
            DO 1100 NML = 1, NMTMAX
               WDTOR( NMTLST(NML), K ) 
     &              =  EIGVCR( NMKMTX(NML,K,1) ) 
 1100    CONTINUE 
      ENDIF
*
      IF ( OAPOR )THEN
         DO 1200 K = 2, KMAX-2
            DO 1200 NML = 1, NMPMAX
               WDDPOR( NMPLST(NML), K ) 
     &              = EIGVCR( NMKMTX(NML,K,2) ) 
 1200    CONTINUE 
      ENDIF
*
      IF ( OAT ) THEN
         DO 1300 K = 1, KMAX-1
            DO 1300 NML = 1, NMQMAX
               WDT( NMQLST(NML), K ) 
     &              = EIGVCR( NMKMTX(NML,K,3) )
 1300    CONTINUE 
      ENDIF
*
      CALL BNDRY
     M          ( WDTOR , WDPOR , WDT  , WDDPOR, 
     C            NMO   ,
     C            ARAD  , DRAD                   )
*
*"     < 2. ͭ٥ȥη׻(ʻ) >
*
      CALL GENGD
     O         ( GDU   , GDV   , GDW   , GDT   , 
     O           GDTOR , GDPOR ,
     I           WDTOR , WDPOR , WDT   , 
     C           FLAPLA, UVFACT, 
     C           ARAD  , DRAD                    )
*
      RETURN
      END
